unit UnitRasdial;
//michel.bardou@wanadoo.fr
//http://perso.wanadoo.fr/bardou/michel/

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Panel2: TPanel;
    EditNumDeTelephone: TEdit;
    EditEntryName: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    EditIdentifiant: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    EditMotDePasse: TEdit;
    Memo1: TMemo;
    Panel1: TPanel;
    Label1: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;


var
  Form1: TForm1;

implementation

{$R *.DFM}

Uses UnitRasAPI32;


var   HandleDeLaConnexion: HRASConn;



procedure fermeConnexion(HandleConnexion:HRASConn);
var
  ReponseFonction   :DWord;
  RASConnStatus     :TRASConnStatus;
  ResultatRasHangUp :DWord;
begin
  if HandleConnexion<>0 then
  begin
    RASConnStatus.dwSize := Sizeof(TRASConnStatus);
    ResultatRasHangUp:= RasHangUp(HandleConnexion);
    if ResultatRasHangUp=0 then //si pas d'erreur
    // la boucle suivante permet de ne pas rendre la main tant que la dconnexion n'est pas termine
    // voir aide  ce sujet sur aide API RasHangUp
    repeat
      ReponseFonction := RasGetConnectStatus(HandleConnexion, @RASConnStatus);
      sleep(0);
    until ReponseFonction = ERROR_INVALID_HANDLE
    else showMessage('erreur RasHangUp');
  end;
end;


procedure TForm1.Button1Click(Sender: TObject);
var
  ParametreConnexion:TRASDialParams;
  RasdialExtensions:  TRASDIALEXTENSIONS;
  ResultatRasDial:integer;
  ChaineRepresentantLErreur:array[0..255]of char;
begin
  screen.cursor := crhourglass;
  label6.Caption:='';

  RasdialExtensions.dwSize:=sizeof(RasdialExtensions);
  RasdialExtensions.dwfOptions:=0;

  FillChar(ParametreConnexion, SizeOf(ParametreConnexion), 0);

  ParametreConnexion.dwSize:=sizeof(TRASDialParams);
  strCopy(ParametreConnexion.szEntryName,   PChar(EditEntryName.Text));
  strCopy(ParametreConnexion.szPhoneNumber, PChar(EditNumDeTelephone.Text));
  strCopy(ParametreConnexion.szUserName,    PChar(EditIdentifiant.Text));
  strCopy(ParametreConnexion.szPassword,    PChar(EditMotDePasse.Text));
  ParametreConnexion.szCallbackNumber:='';
  ParametreConnexion.szDomain:='';
  HandleDeLaConnexion:=0;

  ResultatRasDial:=RasDial(@RasdialExtensions,   { pointer to function extensions data }
      nil,        { pointer to full path and filename of phonebook file}
      @ParametreConnexion, //lpRasDialParams : PRASDIALPARAMS;  { pointeur vers les paramtre d'appel de la connexion}
      0,//dwNotifierType : DWORD;       {  specifies type of RasDial event handler}
      0,//lpvNotifier: DWORD;           { specifies a handler for RasDial events}
      HandleDeLaConnexion// var rasConn: HRASConn   { handle de la connexion}
     );
  Label1.Caption:=IntToStr(ResultatRasDial);
  screen.cursor := crdefault;
  if ResultatRasDial <> 0 then
  begin
    RasGetErrorString(ResultatRasDial, @ChaineRepresentantLErreur, SizeOf(ChaineRepresentantLErreur));
    label6.Caption:= String(ChaineRepresentantLErreur);
    fermeConnexion(HandleDeLaConnexion);
  end;
end;



procedure TForm1.Button2Click(Sender: TObject);

begin
  fermeConnexion(HandleDeLaConnexion);
end;

end.
